//IP.BIN Dumper
//This programm dumps the IP0000.BIN from a GD-Rom
//21.August 2000
//2000 by gonzo

#include<stdio.h>
#include<conio.h>
#include<stdlib.h>
#include<dos.h>
#include "d:\SECTOR~1.h" //MSCDEX Functions

void main()
{
	CDInfo cdinfo;
	cdinfo.GetInfo();
	
	FILE *fp;
	char drive;
	char far *buffer;
	buffer=new char[2048]; //buffer for the sectors you wanna read (2048kb per sector!)

	clrscr();

	textmode(64);
	printf("IP0000.BIN Dumper  21.08.2000       by gonzo\n\n");

	//MSCDEX installed?
	if(!cdinfo.Installed())
	{
		printf("You must have MSCDEX installed to use this programm!\n");
		getch();
		delete[] buffer;
		exit(1);
	}

	//Some Info
	printf("\nNumber of CD-Drives : %d\n",cdinfo.Get_Num_of_Drives());
	printf("First Drive is %c:\\\n",cdinfo.Get_First_Drive());
	printf("MSCDX Version %d.%d\n",cdinfo.Get_Version_Upper(),cdinfo.Get_Version_Lower());


	//Where is the GD?
	printf("\nWhich drive to read? :");
	drive=getch();
	printf(" %c ",drive);//get the ASCII name of the drive
	drive-=97;//Convert the ASCII name of the drive to decimal 
		  //For example your CD-Drive with the GD is E:\.
		  //You enter e(your keyboard press is always lowercase)
		  //e=101 in ASCII but the function Read_Sector needs the drive ID in the following decimal form
		  //0=A,1=B,.... that means E:\ is 4 and 101-97=4 Easy huh?
		  


	printf("\n\nDumping:");
	printf("\n------\n\n");

	cdinfo.Read_Sector(drive,buffer,1,0); //Read the first sector


	//Check if a GD is in the drive
	//Does only work sometimes with Win98 and never with Win95 so you better cut it out
	if(buffer[0]!='S')//First String on a GD is always "SEGA KATANA" so the first char must be 'S'
	{
		clrscr();
		printf("Disc in drive %c:\\ is not a GD-Rom\n",drive+65);
		delete[] buffer;
		getch();
		exit(1);
	}


	//Do the dumping
	fp=fopen("ip0000.bin","w");
	fwrite(buffer,256,1,fp); //Only save the first 256 Bytes wich is the IP0000.BIN
	fclose(fp);

	printf("IP0000.BIN written\n");
	getch();


	delete[] buffer;

	clrscr();
	printf("Bye");
}
